<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>XmlInputArchive.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute</a> &gt; <span class="el_source">XmlInputArchive.java</span></div><h1>XmlInputArchive.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;
/**
 *
 */
class XmlInputArchive implements InputArchive {
    
    static private class Value {
        private String type;
        private StringBuffer sb;
        
<span class="nc" id="L41">        public Value(String t) {</span>
<span class="nc" id="L42">            type = t;</span>
<span class="nc" id="L43">            sb = new StringBuffer();</span>
<span class="nc" id="L44">        }</span>
        public void addChars(char[] buf, int offset, int len) {
<span class="nc" id="L46">            sb.append(buf, offset, len);</span>
<span class="nc" id="L47">        }</span>
<span class="nc" id="L48">        public String getValue() { return sb.toString(); }</span>
<span class="nc" id="L49">        public String getType() { return type; }</span>
    }
    
    private static class XMLParser extends DefaultHandler {
<span class="nc" id="L53">        private boolean charsValid = false;</span>
        
        private ArrayList&lt;Value&gt; valList;
        
<span class="nc" id="L57">        private XMLParser(ArrayList&lt;Value&gt; vlist) {</span>
<span class="nc" id="L58">            valList = vlist;</span>
<span class="nc" id="L59">        }</span>
        
<span class="nc" id="L61">        public void startDocument() throws SAXException {}</span>
        
<span class="nc" id="L63">        public void endDocument() throws SAXException {}</span>
        
        public void startElement(String ns,
                String sname,
                String qname,
                Attributes attrs) throws SAXException {
<span class="nc" id="L69">            charsValid = false;</span>
<span class="nc bnc" id="L70" title="All 2 branches missed.">            if (&quot;boolean&quot;.equals(qname) ||</span>
<span class="nc bnc" id="L71" title="All 2 branches missed.">                    &quot;i4&quot;.equals(qname) ||</span>
<span class="nc bnc" id="L72" title="All 2 branches missed.">                    &quot;int&quot;.equals(qname) ||</span>
<span class="nc bnc" id="L73" title="All 2 branches missed.">                    &quot;string&quot;.equals(qname) ||</span>
<span class="nc bnc" id="L74" title="All 2 branches missed.">                    &quot;double&quot;.equals(qname) ||</span>
<span class="nc bnc" id="L75" title="All 2 branches missed.">                    &quot;ex:i1&quot;.equals(qname) ||</span>
<span class="nc bnc" id="L76" title="All 2 branches missed.">                    &quot;ex:i8&quot;.equals(qname) ||</span>
<span class="nc bnc" id="L77" title="All 2 branches missed.">                    &quot;ex:float&quot;.equals(qname)) {</span>
<span class="nc" id="L78">                charsValid = true;</span>
<span class="nc" id="L79">                valList.add(new Value(qname));</span>
<span class="nc bnc" id="L80" title="All 2 branches missed.">            } else if (&quot;struct&quot;.equals(qname) ||</span>
<span class="nc bnc" id="L81" title="All 2 branches missed.">                &quot;array&quot;.equals(qname)) {</span>
<span class="nc" id="L82">                valList.add(new Value(qname));</span>
            }
<span class="nc" id="L84">        }</span>
        
        public void endElement(String ns,
                String sname,
                String qname) throws SAXException {
<span class="nc" id="L89">            charsValid = false;</span>
<span class="nc bnc" id="L90" title="All 2 branches missed.">            if (&quot;struct&quot;.equals(qname) ||</span>
<span class="nc bnc" id="L91" title="All 2 branches missed.">                    &quot;array&quot;.equals(qname)) {</span>
<span class="nc" id="L92">                valList.add(new Value(&quot;/&quot;+qname));</span>
            }
<span class="nc" id="L94">        }</span>
        
        public void characters(char buf[], int offset, int len)
        throws SAXException {
<span class="nc bnc" id="L98" title="All 2 branches missed.">            if (charsValid) {</span>
<span class="nc" id="L99">                Value v = valList.get(valList.size()-1);</span>
<span class="nc" id="L100">                v.addChars(buf, offset,len);</span>
            }
<span class="nc" id="L102">        }</span>
        
    }
    
<span class="nc" id="L106">    private class XmlIndex implements Index {</span>
        public boolean done() {
<span class="nc" id="L108">            Value v = valList.get(vIdx);</span>
<span class="nc bnc" id="L109" title="All 2 branches missed.">            if (&quot;/array&quot;.equals(v.getType())) {</span>
<span class="nc" id="L110">                valList.set(vIdx, null);</span>
<span class="nc" id="L111">                vIdx++;</span>
<span class="nc" id="L112">                return true;</span>
            } else {
<span class="nc" id="L114">                return false;</span>
            }
        }
<span class="nc" id="L117">        public void incr() {}</span>
    }
    
    private ArrayList&lt;Value&gt; valList;
    private int vLen;
    private int vIdx;
    
    private Value next() throws IOException {
<span class="nc bnc" id="L125" title="All 2 branches missed.">        if (vIdx &lt; vLen) {</span>
<span class="nc" id="L126">            Value v = valList.get(vIdx);</span>
<span class="nc" id="L127">            valList.set(vIdx, null);</span>
<span class="nc" id="L128">            vIdx++;</span>
<span class="nc" id="L129">            return v;</span>
        } else {
<span class="nc" id="L131">            throw new IOException(&quot;Error in deserialization.&quot;);</span>
        }
    }
    
    static XmlInputArchive getArchive(InputStream strm)
    throws ParserConfigurationException, SAXException, IOException {
<span class="nc" id="L137">        return new XmlInputArchive(strm);</span>
    }
    
    /** Creates a new instance of BinaryInputArchive */
    public XmlInputArchive(InputStream in)
<span class="nc" id="L142">    throws ParserConfigurationException, SAXException, IOException {</span>
<span class="nc" id="L143">        valList = new ArrayList&lt;Value&gt;();</span>
<span class="nc" id="L144">        DefaultHandler handler = new XMLParser(valList);</span>
<span class="nc" id="L145">        SAXParserFactory factory = SAXParserFactory.newInstance();</span>
<span class="nc" id="L146">        SAXParser parser = factory.newSAXParser();</span>
<span class="nc" id="L147">        parser.parse(in, handler);</span>
<span class="nc" id="L148">        vLen = valList.size();</span>
<span class="nc" id="L149">        vIdx = 0;</span>
<span class="nc" id="L150">    }</span>
    
    public byte readByte(String tag) throws IOException {
<span class="nc" id="L153">        Value v = next();</span>
<span class="nc bnc" id="L154" title="All 2 branches missed.">        if (!&quot;ex:i1&quot;.equals(v.getType())) {</span>
<span class="nc" id="L155">            throw new IOException(&quot;Error deserializing &quot;+tag+&quot;.&quot;);</span>
        }
<span class="nc" id="L157">        return Byte.parseByte(v.getValue());</span>
    }
    
    public boolean readBool(String tag) throws IOException {
<span class="nc" id="L161">        Value v = next();</span>
<span class="nc bnc" id="L162" title="All 2 branches missed.">        if (!&quot;boolean&quot;.equals(v.getType())) {</span>
<span class="nc" id="L163">            throw new IOException(&quot;Error deserializing &quot;+tag+&quot;.&quot;);</span>
        }
<span class="nc" id="L165">        return &quot;1&quot;.equals(v.getValue());</span>
    }
    
    public int readInt(String tag) throws IOException {
<span class="nc" id="L169">        Value v = next();</span>
<span class="nc bnc" id="L170" title="All 2 branches missed.">        if (!&quot;i4&quot;.equals(v.getType()) &amp;&amp;</span>
<span class="nc bnc" id="L171" title="All 2 branches missed.">                !&quot;int&quot;.equals(v.getType())) {</span>
<span class="nc" id="L172">            throw new IOException(&quot;Error deserializing &quot;+tag+&quot;.&quot;);</span>
        }
<span class="nc" id="L174">        return Integer.parseInt(v.getValue());</span>
    }
    
    public long readLong(String tag) throws IOException {
<span class="nc" id="L178">        Value v = next();</span>
<span class="nc bnc" id="L179" title="All 2 branches missed.">        if (!&quot;ex:i8&quot;.equals(v.getType())) {</span>
<span class="nc" id="L180">            throw new IOException(&quot;Error deserializing &quot;+tag+&quot;.&quot;);</span>
        }
<span class="nc" id="L182">        return Long.parseLong(v.getValue());</span>
    }
    
    public float readFloat(String tag) throws IOException {
<span class="nc" id="L186">        Value v = next();</span>
<span class="nc bnc" id="L187" title="All 2 branches missed.">        if (!&quot;ex:float&quot;.equals(v.getType())) {</span>
<span class="nc" id="L188">            throw new IOException(&quot;Error deserializing &quot;+tag+&quot;.&quot;);</span>
        }
<span class="nc" id="L190">        return Float.parseFloat(v.getValue());</span>
    }
    
    public double readDouble(String tag) throws IOException {
<span class="nc" id="L194">        Value v = next();</span>
<span class="nc bnc" id="L195" title="All 2 branches missed.">        if (!&quot;double&quot;.equals(v.getType())) {</span>
<span class="nc" id="L196">            throw new IOException(&quot;Error deserializing &quot;+tag+&quot;.&quot;);</span>
        }
<span class="nc" id="L198">        return Double.parseDouble(v.getValue());</span>
    }
    
    public String readString(String tag) throws IOException {
<span class="nc" id="L202">        Value v = next();</span>
<span class="nc bnc" id="L203" title="All 2 branches missed.">        if (!&quot;string&quot;.equals(v.getType())) {</span>
<span class="nc" id="L204">            throw new IOException(&quot;Error deserializing &quot;+tag+&quot;.&quot;);</span>
        }
<span class="nc" id="L206">        return Utils.fromXMLString(v.getValue());</span>
    }
    
    public byte[] readBuffer(String tag) throws IOException {
<span class="nc" id="L210">        Value v = next();</span>
<span class="nc bnc" id="L211" title="All 2 branches missed.">        if (!&quot;string&quot;.equals(v.getType())) {</span>
<span class="nc" id="L212">            throw new IOException(&quot;Error deserializing &quot;+tag+&quot;.&quot;);</span>
        }
<span class="nc" id="L214">        return Utils.fromXMLBuffer(v.getValue());</span>
    }
    
    public void readRecord(Record r, String tag) throws IOException {
<span class="nc" id="L218">        r.deserialize(this, tag);</span>
<span class="nc" id="L219">    }</span>
    
    public void startRecord(String tag) throws IOException {
<span class="nc" id="L222">        Value v = next();</span>
<span class="nc bnc" id="L223" title="All 2 branches missed.">        if (!&quot;struct&quot;.equals(v.getType())) {</span>
<span class="nc" id="L224">            throw new IOException(&quot;Error deserializing &quot;+tag+&quot;.&quot;);</span>
        }
<span class="nc" id="L226">    }</span>
    
    public void endRecord(String tag) throws IOException {
<span class="nc" id="L229">        Value v = next();</span>
<span class="nc bnc" id="L230" title="All 2 branches missed.">        if (!&quot;/struct&quot;.equals(v.getType())) {</span>
<span class="nc" id="L231">            throw new IOException(&quot;Error deserializing &quot;+tag+&quot;.&quot;);</span>
        }
<span class="nc" id="L233">    }</span>
    
    public Index startVector(String tag) throws IOException {
<span class="nc" id="L236">        Value v = next();</span>
<span class="nc bnc" id="L237" title="All 2 branches missed.">        if (!&quot;array&quot;.equals(v.getType())) {</span>
<span class="nc" id="L238">            throw new IOException(&quot;Error deserializing &quot;+tag+&quot;.&quot;);</span>
        }
<span class="nc" id="L240">        return new XmlIndex();</span>
    }
    
<span class="nc" id="L243">    public void endVector(String tag) throws IOException {}</span>
    
    public Index startMap(String tag) throws IOException {
<span class="nc" id="L246">        return startVector(tag);</span>
    }
    
<span class="nc" id="L249">    public void endMap(String tag) throws IOException { endVector(tag); }</span>

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>